//
// T88D88ϊc[ v0.01 by RHG
//	ȂƒBGMT[JXc
//

#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>

typedef		unsigned char	BYTE;
typedef		unsigned short	WORD;
typedef		unsigned long	DWORD;
typedef		int				BOOL;
#define		TRUE			1
#define		FALSE			0

#define		D88_NOERR			0
#define		D88_ERROR			-1
#define		D88_DISK_FULL		-2
#define		D88_DIR_FULL		-3
#define		D88_FILE_NOT_FOUND	-4
#define		D88_ALREADY_EXISTS	-5

/*
 *	D88t@Cwb_
 */
typedef struct {
	BYTE	diskname[17];	// fBXN
	BYTE	reserve[9];		// U[u
	BYTE	protect;		// CgveNgtO
	BYTE	media;			// }̎(0x00:2D 0x10:2DD 0x20:2HD)
	DWORD	size;			// fBXNC[W̃TCY
	DWORD	trkoff[164];	// gbNf[^ւ̃ItZbge[u
} D88header;

/*
 *	D88t@CZN^wb_
 */
typedef struct {
	BYTE	cylinder;		// V_ԍ
	BYTE	head;			// wbhԍ
	BYTE	sector;			// ZN^ԍ
	BYTE	secsize;		// ZN^TCY
	WORD	seccnt;			// gbNɑ݂ZN^
	BYTE	density;		// L^x(0x00:{x 0x40:Px)
	BYTE	deldata;		// DELETED DATA
	BYTE	status;			// Xe[^X
	BYTE	reserve[5];		// U[u
	WORD	datasize;		// ZN^f[^TCY
	BYTE	data[256];		// ZN^f[^
} D88sector;

/*
 *	N88-BASICfBNg
 */
typedef struct {
	BYTE	name[6];		// t@C
	BYTE	ext[3];			// gq
	BYTE	attr;			// t@C^Cv/
	BYTE	cluster;		// X^[gNX^
	BYTE	reserve[5];		// U[u
} N88dir;

/*
 *	ZN^΂񂲂
 */
typedef struct {
	BYTE	cyl;			// V_
	BYTE	hed;			// wbh
	BYTE	sec;			// ZN^ԍ
} CHRN;


typedef enum {
	FILE_T88 = 0,
	FILE_CMT,
} FileType;

D88header	hdr;
BYTE		FatBuf[256];
N88dir		DirBuf[16];
CHRN		dir;
int			dir_size;
int			max_cluster, cluster_size, max_sector;
FILE		*Dfp;
FileType	filetype = FILE_T88;

/*
 *	D88t@CI[v
 */
BOOL OpenD88(char *fname)
{
	extern BOOL LoadFatD88(void);

	if ((Dfp = fopen(fname, "r+b")) == NULL) {
		return FALSE;
	}

	fseek(Dfp, 0, SEEK_SET);
	fread(&hdr, sizeof(D88header), 1, Dfp);

	// for NEC
	if (hdr.media == 0x20) {
		cluster_size = 26;
		max_cluster = 154;
		max_sector = 26;
		dir.cyl = 35;
		dir.hed = 0;
		dir.sec = 1;
		dir_size = 24;
	}
	else if (hdr.media == 0x00) {
		cluster_size = 8;
		max_cluster = 160;
		max_sector = 16;
		dir.cyl = 18;
		dir.hed = 1;
		dir.sec = 1;
		dir_size = 14;
	}
	LoadFatD88();

	return TRUE;
}

/*
 *	D88t@CN[Y
 */
BOOL CloseD88(void)
{
	extern BOOL SaveFatD88(void);

	if (Dfp == NULL) {
		return FALSE;
	}

	fclose(Dfp);
	return TRUE;
}

/*
 *	D88t@CPZN^[h
 */
BOOL ReadSectorD88(BYTE trk, BYTE sid, BYTE sct, BYTE *buf)
{
	int			trkoff;
	int			offset;
	int			totalsct;
	int			sect;
	D88sector	sctd;

	if (hdr.media == 0x40) {
		// WinSMC 1DDt@CΉ(C~iV)
		trkoff = hdr.trkoff[trk];
	}
	else {
		trkoff = hdr.trkoff[trk * 2 + (sid & 1)];
	}
	fseek(Dfp, trkoff, SEEK_SET);
	fread(&sctd, 1, 16, Dfp);
	totalsct = sctd.seccnt;

	for (sect = 0; sect < totalsct; sect++) {
		fseek(Dfp, trkoff, SEEK_SET);
		fread(&sctd, 1, 16, Dfp);
		if ((sctd.head == sid) && (sctd.sector == sct)) {
			fread(buf, 1, sctd.datasize, Dfp);
			return TRUE;
		}
		trkoff += (sctd.datasize + 16);
	}

	return FALSE;
}

/*
 *	D88t@CւPZN^Cg
 */
BOOL WriteSectorD88(BYTE trk, BYTE sid, BYTE sct, BYTE *buf)
{
	int			trkoff;
	int			offset;
	int			totalsct;
	int			sect;
	D88sector	sctd;

	if (hdr.media == 0x40) {
		// WinSMC 1DDt@CΉ(C~iV)
		trkoff = hdr.trkoff[trk];
	}
	else {
		trkoff = hdr.trkoff[trk * 2 + (sid & 1)];
	}
	fseek(Dfp, trkoff, SEEK_SET);
	fread(&sctd, 1, 16, Dfp);
	totalsct = sctd.seccnt;

	for (sect = 0; sect < totalsct; sect++) {
		fseek(Dfp, trkoff, SEEK_SET);
		fread(&sctd, 1, 16, Dfp);
		if ((sctd.head == sid) && (sctd.sector == sct)) {
			fseek(Dfp, trkoff + 16, SEEK_SET);
			fwrite(buf, 1, sctd.datasize, Dfp);
			return TRUE;
		}
		trkoff += (sctd.datasize + 16);
	}

	return FALSE;
}

/*
 *	FAT[h
 */
BOOL LoadFatD88(void)
{
	if (hdr.media == 0x20) {
		ReadSectorD88(35, 0, 24, (BYTE *)&FatBuf);
	}
	else {
		ReadSectorD88(18, 1, 14, (BYTE *)&FatBuf);
	}

	return TRUE;
}

/*
 *	FATZ[u
 */
BOOL SaveFatD88(void)
{
	int i;

	for (i=0; i<3; i++) {
		if (hdr.media == 0x20) {
			WriteSectorD88(35, 0, 24 + i, (BYTE *)&FatBuf);
		}
		else {
			WriteSectorD88(18, 1, 14 + i, (BYTE *)&FatBuf);
		}
	}

	return TRUE;
}

/*
 *	󂫃NX^vZ
 */
int DskfD88(void)
{
	int		clus = 0, i;

	/* 󂫃NX^𐔂 */
	for (i = 0; i < max_cluster; i++) {
		if (FatBuf[i] == 0xFF)	clus ++;
	}

	return clus;
}


/*
 *	gp\NX^vZ
 */
BYTE DskcD88(void)
{
	int		clus = 0, i;

	/* VXe\ȊÕNX^𐔂 */
	for (i = 0; i < max_cluster; i++) {
		if (FatBuf[i] != 0xFE)	clus ++;
	}

	return clus;
}

/*
 *	gpNX^vZ
 */
int UseClusterD88(BYTE cluster)
{
	int		clus = 1;

	/* VXe\ȊÕNX^𐔂 */
	while ((FatBuf[cluster] < 0xc0) && (cluster < max_cluster)) {
		clus ++;
		cluster = FatBuf[cluster];
	} 

	return clus;
}

/*
 *	wTCỸt@C̕KvNX^vZ
 */
int ClusterSizeD88(int filesize)
{
	int i = cluster_size * 256;
	return (filesize + (i - 1)) / i;
}

/*
 *	w肳ꂽt@C̃fBNgXbgԍԂ
 */
int GetDirSlotD88(char *filename)
{
	char filnam[10];
	int i, j, sec, slot;

	// N88`t@C𐶐
	memset(filnam, 0x20, 9);
	filnam[9] = '\0';
	for (i=0; i<7; i++) {
		if (filename[i] == '.') {
			memcpy(filnam, filename, i);
			if ((int)strlen(filename) > (i + 1)) {
				memcpy(&filnam[6], &filename[i + 1], strlen(filename) - i);
			}
			break;
		}
	}
	if (filnam[0] == 0x20) {
		// sIhȂ̏ꍇ̃V
		memcpy(filnam, filename, strlen(filename));
	}

	// 蔲fBNg
	slot = D88_FILE_NOT_FOUND;
	i = j = 0;
	sec = dir.sec;
	ReadSectorD88(dir.cyl, dir.hed, sec, (BYTE *)DirBuf);
	while (DirBuf[i].name[0] != 0xff) {
		if (DirBuf[i].name[0]) {
			if (!memcmp(DirBuf[i].name, filnam, 9)) {
				slot = j;
				break;
			}
		}
		j++;

		// fBNg|C^XV(KvłΎZN^[h)
		i++;
		if (i >= 16) {
			i = 0;
			sec ++;
			ReadSectorD88(dir.cyl, dir.hed, sec, (BYTE *)DirBuf);
		}
	}

	return slot;
}

/*
 *	󂫃NX^ԍԂ
 */
BYTE GetFreeClusterD88(void)
{
	int		i;

	for (i = 0; i < max_cluster; i++) {
		if (FatBuf[i] == 0xFF) return i;
	}
	return -1;
}

/*
 *	󂫃fBNgXbgԍԂ
 */
int GetFreeDirSlotD88(void)
{
	int i, j, sec;

	// 蔲fBNg
	i = j = 0;
	sec = dir.sec;
	while (sec < (dir.sec + dir_size - 1)) {
		ReadSectorD88(dir.cyl, dir.hed, sec, (BYTE *)DirBuf);
		if ((DirBuf[i].name[0] == 0xff) || (DirBuf[i].name[0] == 0x00)) {
			return j;
		}
		j++;

		// fBNg|C^XV(KvłΎZN^[h)
		i++;
		if (i >= 16) {
			i = 0;
			sec ++;
			ReadSectorD88(dir.cyl, dir.hed, sec, (BYTE *)DirBuf);
		}
	}

	return D88_DIR_FULL;
}

/*
 *	fBNgXbgɃt@Co^
 */
int WriteDirSlotD88(char *filename, BYTE attr, int cluster)
{
	char filnam[10];
	int i, j, sec;
	int slot;

	// N88`t@C𐶐
	memset(filnam, 0x20, 9);
	filnam[9] = '\0';
	for (i=0; i<7; i++) {
		if (filename[i] == '.') {
			memcpy(filnam, filename, i);
			if ((int)strlen(filename) > (i + 1)) {
				memcpy(&filnam[6], &filename[i + 1], strlen(filename) - i);
			}
			break;
		}
	}
	if (filnam[0] == 0x20) {
		// sIhȂ̏ꍇ̃V
		memcpy(filnam, filename, strlen(filename));
	}

	// 蔲fBNg
	slot = GetFreeDirSlotD88();
	if (slot == D88_DIR_FULL) {
		return slot;
	}

	ReadSectorD88(dir.cyl, dir.hed, dir.sec + (slot / 16), (BYTE *)DirBuf);
	memcpy(DirBuf[slot % 16].name, filnam, 9);
	DirBuf[slot % 16].attr = attr;
	DirBuf[slot % 16].cluster = cluster;
	WriteSectorD88(dir.cyl, dir.hed, dir.sec + (slot / 16), (BYTE *)DirBuf);

	return D88_NOERR;
}

/*
 *	t@CfBXNC[Wɏ
 */
int WriteFileD88(char *filename, BYTE attr, BYTE *buf, int size)
{
	int cluster_no, start_cluster;
	int file_clusters;
	int sectors;
	CHRN wrt;
	int i;
	char buf0[256];

	// KvNX^TCYE󂫐擪NX^Get
	file_clusters = ClusterSizeD88(size);
	start_cluster = cluster_no = GetFreeClusterD88();

	// ܂fBXNɓ肫邩`FbN
	if (file_clusters > DskfD88()) {
		return D88_DISK_FULL;
	}

	// ̃t@CƓłȂ`FbN
	if (GetDirSlotD88(filename) >= 0) {
		return D88_ALREADY_EXISTS;
	}

	// ɋ󂫃fBNgXbg`FbN
	if (GetFreeDirSlotD88() < 0) {
		return D88_DIR_FULL;
	}

	// KVKV
	sectors = 0;
	do {
		// t@CJLR
		wrt.cyl = ((cluster_no * cluster_size) / (max_sector * 2));
		wrt.hed = ((cluster_no * cluster_size) / max_sector) % 2;
		wrt.sec = ((cluster_no * cluster_size) % max_sector) + 1;
		for (i=0; i<cluster_size; i++) {
			if (!WriteSectorD88(wrt.cyl, wrt.hed, wrt.sec + i, buf)) {
				return D88_ERROR;
			}
			sectors ++;
			buf += 256;
			if ((size -= 256) < 0) {
				for (i++; i < cluster_size; i++) {
					memset(buf0, 0, 256);
					if (!WriteSectorD88(wrt.cyl, wrt.hed, wrt.sec + i, buf0)) {
						return D88_ERROR;
					}
				}
				break;
			}
		}

		// FATJLR
		if (size > 0) {
			// NX^
			FatBuf[i = cluster_no] = 0xfe;
			FatBuf[i] = cluster_no = GetFreeClusterD88();
		}
		else {
			// t@CI
			FatBuf[cluster_no] = ((sectors - 1) % cluster_size) + 0xc1;
		}
	} while (size > 0);

	// fBNgXbg,FAT
	if (WriteDirSlotD88(filename, attr, start_cluster) == D88_NOERR) {
		// FAT
		SaveFatD88();
	}

	return D88_NOERR;
}

/*
 *	܂E蔲FILESV
 */
void FilesD88(void)
{
	static const char FilType[4] = { ' ', '*', '.', '.' };
	char nam[7], ext[4];
	int i, sec;

	// 蔲FILESV
	i = 0;
	sec = dir.sec;
	ReadSectorD88(dir.cyl, dir.hed, sec, (BYTE *)DirBuf);
	while (DirBuf[i].name[0] != 0xff) {
		if (DirBuf[i].name[0]) {
			memset(nam, 0, 7);
			memset(ext, 0, 4);
			memcpy(nam, DirBuf[i].name, 6);
			memcpy(ext, DirBuf[i].ext, 3);
			printf("%-6s%c%-3s %3d  ",
				nam,
				FilType[((DirBuf[i].attr & 0x80) >> 6) | DirBuf[i].attr & 1],
				ext,
				UseClusterD88(DirBuf[i].cluster));
		}

		// fBNg|C^XV(KvłΎZN^[h)
		i++;
		if (i >= 16) {
			i = 0;
			sec ++;
			ReadSectorD88(dir.cyl, dir.hed, sec, (BYTE *)DirBuf);
		}
	}

	// I}GF-BASIC
	printf("\n%d Clusters Free\n", DskfD88());
}


BYTE fbuf[65536];
int bufptr = 0;

void bufwrite(BYTE *datptr, int count) {
	memcpy(&fbuf[bufptr], datptr, count);
	bufptr += count;
}

int	main(int argc, char *argv[])
{
	FILE *fp;
	unsigned short	tagid, size;
	unsigned short	dsize;
	int ptr;
	char fname[16];
	char header[24];
	BOOL filewrite;
	BYTE secbuf[256];
	char filename[16];
	BYTE buf[65536];
	int sec;
	int i, j;
	int fileofs;
	WORD linkpointer, linenumber;
	BYTE dat;
	BYTE attr;

	printf("T88 to D88 File Copy Tool version 0.01\n");
	printf("Copyright (c) 2003 RyuTak@RPF\n\n");

	if (argc < 3) {
		printf("usage : %s <tapeimage.t88> <diskimage.d88>\n", argv[0]);
		printf("        gq͏ȗs\n");
		return 255;
	}

	if (!OpenD88(argv[2])) {
		printf("%s ̃I[vɎs܂\n", argv[2]);
		return 1;
	}
	LoadFatD88();

	if ((fp = fopen(argv[1], "rb")) == NULL) {
		printf("%s ̃I[vɎs܂\n", argv[1]);
		CloseD88();
		return 1;
	}
	fread(header, 1, 24, fp);
	if (strcmp("PC-8801 Tape Image(T88)", header)) {
		printf("%s CMTt@CƂăI[v܂\n", argv[1]);
		fseek(fp, 0, SEEK_SET);
		filetype = FILE_CMT;
	}
	else {
		printf("%s T88t@CƂăI[v܂\n", argv[1]);
		filetype = FILE_T88;
	}

	filewrite = FALSE;
	ptr = ftell(fp);
	tagid = -1;
	if (filetype == FILE_T88) {
		/* T88 */
		while (!feof(fp) && tagid) {
			fread(&tagid, 1, 2, fp);
			fread(&size, 1, 2, fp);
			switch (tagid) {
				case 0x0000:	// I^O
								break;
				case 0x0001:	// o[W^O
								fread(buf, 1, 2, fp);
								printf("T88t@C̃o[WV%d.%dł\n",
									buf[1], buf[0]);
								break;
				case 0x0100:	// uN^O
				case 0x0102:	// Xy[X^O
								break;
				case 0x0103:	// }[N^O
								if (filewrite) {
									if (fileofs) {
										// EOF`FbN
										for (j=0; j<256; j++) {
											if (fbuf[fileofs - j - 1] == 0x1a) {
												fileofs -= j;
												break;
											}
											else if (fbuf[fileofs - j - 1]) break;
										}
										i = 0;
										sprintf(fname, "%-6s", filename);
										while ((GetDirSlotD88(fname) >= 0) &&
											(i < 999)) {
											i ++;
											sprintf(fname, "%-6s.%03d",
												filename, i);
										}

										if (*((short *)buf) >= 256) {
											attr = 0;
										}
										else {
											attr = 0x80;
										}
										if (!WriteFileD88(
											fname, attr, fbuf, fileofs)) {
											printf("݊ : %s\n", fname);
										}
										else {
											printf("ݎs : %s\n", fname);
										}
									}
									else {
										if (filewrite == 1) printf("ccc\n");
									}
									filewrite --;
								}
								break;
				case 0x0101:	// f[^^O
								fseek(fp, 8, SEEK_CUR);
								fread(&dsize, 1, 2, fp);
	//							printf("DATA (%d bytes)\n", dsize);
								fseek(fp, 2, SEEK_CUR);
								memset(buf, 0, 65536);
								fread(buf, 1, dsize, fp);
								if (!memcmp("", buf, 10)) {
									memcpy(filename, &buf[10], 6);
									filename[6] = '\0';
									for (i=5;i>0;i--) {
										if (filename[i]==0x20) filename[i]=0;
									}
									printf("T88 : %-6s 𔭌܂  ", filename);
									memset(fbuf, 0, 65536);
									filewrite = 2;
									fileofs = 0;
								}
								else if (filewrite) {
									memcpy(&fbuf[fileofs], buf, dsize);
									fileofs += dsize;
								}
								break;
			}
			ptr += (size + 4);
			fseek(fp, ptr, SEEK_SET);
		}
	}
	else {
		/* CMT */
		// wb_`FbN
		while (!feof(fp)) {
			bufptr = 0;
			fread(&dat, 1, 1, fp);
			if (!memcmp("", &dat, 1)) {
				buf[0] = dat;
				fread(&buf[1], 1, 16 - 1, fp);
				if (!memcmp("", buf, 10)) {
					memcpy(filename, &buf[10], 6);
					filename[6] = '\0';
					for (i=5;i>0;i--) {
						if (filename[i]==0x20) filename[i]=0;
					}
					printf("CMT : %-6s 𔭌܂  ", filename);

					// 
					do {
						fread(&linkpointer, 1, 2, fp);
						fread(&linenumber, 1, 2, fp);
						if (linkpointer) {
							bufwrite(&linkpointer, 2);
							bufwrite(&linenumber, 2);
							ptr = 0;
							do {
								fread(&dat, 1, 1, fp);
								switch (dat) {
									case 0x0b : // 8i萔
									case 0x0c : // 16i萔
									case 0x0d : // ѐAhX
									case 0x0e : // ѐsԍ
									case 0x1c : // 16rbg萔
												fread(&buf, 1, 2, fp);
												bufwrite(&dat, 1);
												bufwrite(&buf, 2);
												break;
									case 0x0f : // 8rbg萔
												fread(&buf, 1, 1, fp);
												bufwrite(&dat, 1);
												bufwrite(&buf, 1);
												break;
									case 0x1d : // Px
												fread(&buf, 1, 4, fp);
												bufwrite(&dat, 1);
												bufwrite(&buf, 4);
												break;
									case 0x1e : // {x
												fread(&buf, 1, 8, fp);
												bufwrite(&dat, 1);
												bufwrite(&buf, 8);
												break;
									default	  : bufwrite(&dat, 1);
												break;
								}
							} while (dat);
						}
					} while (linkpointer);

					// write eof
					bufwrite(&linkpointer, 2);
					bufwrite(&linenumber, 2);
					dat = 0x1a;
					bufwrite(&dat, 1);

					attr = 0x80;
					if (!WriteFileD88(filename, attr, fbuf, bufptr)) {
						printf("݊ : %s\n", filename);	
					}
					else {
						printf("ݎs : %s\n", filename);
					}
				}
			}
		}
		fclose(fp);
	}

	CloseD88();
	fclose(fp);

	printf("܂\n");
	return 0;
}
